"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var compressor = pako;
var MemoryStorageService = /** @class */ (function () {
    function MemoryStorageService() {
        this.preferences = new Map();
    }
    MemoryStorageService.prototype.clear = function () {
        this.preferences.clear();
    };
    MemoryStorageService.prototype.put = function (key, value) {
        this.preferences.set(key, value);
    };
    MemoryStorageService.prototype.get = function (key, defaultValue) {
        var value = this.preferences.get(key);
        if (value === undefined || value === null) {
            if (defaultValue === undefined || defaultValue === null) {
                return value;
            }
            else {
                return defaultValue;
            }
        }
        else {
            return value;
        }
    };
    MemoryStorageService.prototype.remove = function (key) {
        this.preferences.delete(key);
    };
    MemoryStorageService.prototype.removeStartsWith = function (startWith) {
        var _this = this;
        this.preferences.forEach(function (value, key) {
            if (key.startsWith(startWith)) {
                _this.remove(key);
            }
        });
    };
    MemoryStorageService.prototype.removeEndsWith = function (endsWith) {
        var _this = this;
        this.preferences.forEach(function (value, key) {
            if (key.endsWith(endsWith)) {
                _this.remove(key);
            }
        });
    };
    MemoryStorageService.prototype.getInCompressFormat = function () {
        var passToServer = {};
        this.preferences.forEach(function (value, key) {
            passToServer[key] = value;
        });
        var binaryString = compressor.deflate(JSON.stringify(passToServer), { to: 'string' });
        return btoa(binaryString);
    };
    MemoryStorageService.prototype.getInStringFormat = function () {
        var passToServer = {};
        this.preferences.forEach(function (value, key) {
            passToServer[key] = value;
        });
        return JSON.stringify(passToServer);
    };
    MemoryStorageService.prototype.putFromCompressFormat = function (compressed) {
        var _this = this;
        this.clear();
        // Do your best
        try {
            var result = compressor.inflate(atob(compressed), { to: 'string' });
            var parsed_1 = JSON.parse(result);
            Object.keys(parsed_1)
                .forEach(function (key) {
                var value = parsed_1[key];
                _this.preferences.set(key, value);
            });
        }
        catch (ex) {
        }
    };
    MemoryStorageService = __decorate([
        core_1.Injectable()
    ], MemoryStorageService);
    return MemoryStorageService;
}());
exports.MemoryStorageService = MemoryStorageService;
//# sourceMappingURL=memory-storage.service.js.map