"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var memory_storage_service_1 = require("./memory-storage.service");
var session_storage_service_1 = require("./session-storage.service");
var local_storage_service_1 = require("./local-storage.service");
var PreferencesService = /** @class */ (function () {
    function PreferencesService(memoryService, localService, sessionService) {
        this.memoryService = memoryService;
        this.localService = localService;
        this.sessionService = sessionService;
        this.storage = PreferencesService_1.IN_MEMORY_STORAGE;
    }
    PreferencesService_1 = PreferencesService;
    PreferencesService.prototype.setStorage = function (storage) {
        if (storage === PreferencesService_1.IN_MEMORY_STORAGE || storage === PreferencesService_1.LOCAL_STORAGE || storage === PreferencesService_1.SESSION_STORAGE) {
            this.storage = storage;
        }
        else {
            console.error('Invalid storage type');
        }
    };
    PreferencesService.prototype.getStorage = function () {
        return this.storage;
    };
    PreferencesService.prototype.usePrefix = function (prefix) {
        if (this.storage === PreferencesService_1.LOCAL_STORAGE) {
            this.localService.usePrefix(prefix);
        }
        else if (this.storage === PreferencesService_1.SESSION_STORAGE) {
            this.sessionService.usePrefix(prefix);
        }
        else {
            console.error('You can not set a prefix for In-memory preferences');
        }
    };
    PreferencesService.prototype.clear = function () {
        if (this.storage === PreferencesService_1.IN_MEMORY_STORAGE) {
            this.memoryService.clear();
        }
        else if (this.storage === PreferencesService_1.LOCAL_STORAGE) {
            this.localService.clear();
        }
        else {
            this.sessionService.clear();
        }
    };
    PreferencesService.prototype.put = function (key, value) {
        if (this.storage === PreferencesService_1.IN_MEMORY_STORAGE) {
            this.memoryService.put(key, value);
        }
        else if (this.storage === PreferencesService_1.LOCAL_STORAGE) {
            this.localService.put(key, value);
        }
        else {
            this.sessionService.put(key, value);
        }
    };
    PreferencesService.prototype.get = function (key, defaultValue) {
        if (this.storage === PreferencesService_1.IN_MEMORY_STORAGE) {
            return this.memoryService.get(key, defaultValue);
        }
        else if (this.storage === PreferencesService_1.LOCAL_STORAGE) {
            return this.localService.get(key, defaultValue);
        }
        else {
            return this.sessionService.get(key, defaultValue);
        }
    };
    PreferencesService.prototype.remove = function (key) {
        if (this.storage === PreferencesService_1.IN_MEMORY_STORAGE) {
            this.memoryService.remove(key);
        }
        else if (this.storage === PreferencesService_1.LOCAL_STORAGE) {
            this.localService.remove(key);
        }
        else {
            this.sessionService.remove(key);
        }
    };
    PreferencesService.prototype.removeStartsWith = function (startWith) {
        if (this.storage === PreferencesService_1.IN_MEMORY_STORAGE) {
            this.memoryService.removeStartsWith(startWith);
        }
        else if (this.storage === PreferencesService_1.LOCAL_STORAGE) {
            this.localService.removeStartsWith(startWith);
        }
        else {
            this.sessionService.removeStartsWith(startWith);
        }
    };
    PreferencesService.prototype.removeEndsWith = function (endsWith) {
        if (this.storage === PreferencesService_1.IN_MEMORY_STORAGE) {
            this.memoryService.removeEndsWith(endsWith);
        }
        else if (this.storage === PreferencesService_1.LOCAL_STORAGE) {
            this.localService.removeEndsWith(endsWith);
        }
        else {
            this.sessionService.removeEndsWith(endsWith);
        }
    };
    PreferencesService.prototype.getInStringFormat = function () {
        if (this.storage === PreferencesService_1.IN_MEMORY_STORAGE) {
            return this.memoryService.getInStringFormat();
        }
        else {
            return '';
        }
    };
    PreferencesService.prototype.getInCompressFormat = function () {
        if (this.storage === PreferencesService_1.IN_MEMORY_STORAGE) {
            return this.memoryService.getInCompressFormat();
        }
        else {
            return '';
        }
    };
    PreferencesService.prototype.putFromCompressFormat = function (compressed) {
        if (this.storage === PreferencesService_1.IN_MEMORY_STORAGE) {
            this.memoryService.putFromCompressFormat(compressed);
        }
    };
    var PreferencesService_1;
    PreferencesService.IN_MEMORY_STORAGE = 1;
    PreferencesService.LOCAL_STORAGE = 2;
    PreferencesService.SESSION_STORAGE = 3;
    PreferencesService = PreferencesService_1 = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [memory_storage_service_1.MemoryStorageService, local_storage_service_1.LocalStorageService, session_storage_service_1.SessionStorageService])
    ], PreferencesService);
    return PreferencesService;
}());
exports.PreferencesService = PreferencesService;
//# sourceMappingURL=preferences.service.js.map